//	SedPc.h		240703		Stadtmueller	mst3	110703
//		SedPc & Sed1Pc & Sed2Pc from Version 98


typedef	unsigned long	LONG;
//typedef	unsigned short	WORD;
//typedef	unsigned char	BYTE;
typedef	unsigned char	CHAR;

//-------+---------+---------+---------+---------+---------+---------+---------+

// declaration of externals defined in file SedIni
//
// 1 Telegram will need 5 Bytes: Cn, Sa, MDat, LDat, LastByte

#define	XMLN		10		// max number of lines in system
#define	TIMEOUT		1000	// timeout n msec for reserve
#define	MAXNAM		32		// max Number of Character in NameString
#define	FREEHANDLE	0		// free handle
#define	EOS			0		// EndOfString Character
	// SEDPC is BUSY in status
#define	TICKINC		10000	// increment of tick-counter in usec
#define	LASTBY		0xA5	// LastByteMarker
#define	SEDPC		0x100	// type marker in upper byte of xma[]
#define	SED1PC		0x200	// type marker in upper byte of xma[]

extern LONG		glDatReg, glStaReg, glCtrReg;	// PortRegister
extern LONG		glNoLin;			// Number of Lines found
extern LONG		glSelLin;			// least selected Line
extern LONG		glLogLin[XMLN];		// logical LineNumbers
extern LONG		glDevAdr[XMLN];		// DeviceAddr of Lines
extern LONG		glModAdr[XMLN];		// ModuleAddr of Lines (from Sed1Pc)
extern LONG		glTelDly;			// Tel DelayTime to get Response
extern LONG		glTickLoop;			// ForLoops per Tick for short WaitTimes
//-------+---------+---------+---------+---------+---------+---------+---------+

// define character
#define	NUL	0
#define	LF	10
#define	CR	13
#define	ESC	27

// SedPc define bits in status and control
#define	BUSY	0x80	// SEDPC is BUSY in status
#define	INMOD	8		// set INput mode
#define	INSTB	9		// set INput mode and STroBe data in
#define	OUTMOD	0		// set OUTput mode
#define	OUTSTB	1		// set OUTput mode and STroBe data out
#define	OUTEND	3		// like OUTSTB and PcEndofTelegrFrame
#define	CLR		4		// set CLeaR SEDPC-fifo, setup io-addr
#define	OLDSEL	0x50	// status after SELECT Sed1Pc Instruction

// Sed1Pc declaration of control-bits
#define	IDLE	0x0		// control-lines idle
#define	INIT	0x4		// clear to SEDPC, clear fifo's
#define	SELECT	0x8		// select 1 of 8 modules
#define	WRIDA	0x1		// write data to parallel-port
#define	WRILA	0x3		// write last data-byte
#define	RDUPP	0xA		// read upper nibble
#define	RDLOW	0x6		// read lower nibble
#define	RDSTA	0x2		// read fifo-status

// Sed1Pc declaration of status-bits as response to action
#define	SINI	0x78	// status after INIT
#define	SSEL	0x90	// status after SELECT
#define	SDES	0x78	// status after DESELECT all
#define	SWR		0x90	// status after WRITE no error
#define	SRSP	0x80	// bit /RESPONSE in status

#define	IFFF	0x40	// masks for FifoFlag bits
#define	IFEF	0x20
#define	OFFF	0x10
#define	OFEF	0x8

//-------+---------+---------+---------+---------+---------+---------+---------+

// modified functions from <sys/io.h>

static __inline unsigned char
_inp (unsigned short int port)
{
  unsigned char _v;

  __asm__ __volatile__ ("inb %w1,%0":"=a" (_v):"Nd" (port));
  return _v;
}

static __inline void
_outp (unsigned short int port, unsigned char value)
{
  __asm__ __volatile__ ("outb %b0,%w1": :"a" (value), "Nd" (port));
}
//-------+---------+---------+---------+---------+---------+---------+---------+


// function prototypes

// SedLow
void sedlpt ( void );
LONG sedsel ( LONG lLn );
LONG hstrtu (CHAR *hstr, LONG *pdat);
LONG dstrtu (CHAR *dstr, LONG *pdat);
LONG sed0wt ( LONG *stat );
LONG sed1wt ( void );
LONG sedrd1 ( LONG *dat );
LONG sedrd1 ( LONG *dat );
LONG sedwr0 ( LONG long1 );
LONG sedwr1 ( LONG long1 );
LONG sedwr2 ( LONG long1 );
LONG sedwr4 ( LONG long1, LONG long2 );

// SedIni
void SedLib ( CHAR *lpszVer );
void SedIni ( LONG *lplFndLin, LONG *lrglLinNum, LONG *lrglDevAdd, LONG *lplErr );
void SedExi ( LONG *lplErr );

// SedCrw
void SedClr ( LONG lLn, LONG *lplDly, LONG *lplErr );
void SedRd  ( LONG lLn, LONG lCn, LONG lSa, LONG *lplDat, LONG *lplErr );
void SedWr  ( LONG lLn, LONG lCn, LONG lSa, LONG wDat, LONG *lplErr );

// SedMul
void SedPut ( LONG lLn, LONG *lplNum, LONG *lrglArr, LONG *lplErr );
void SedGet ( LONG lLn, LONG *lplNum, LONG *lrglArr, LONG *lplErr );

// SedTst
void SedTst ( LONG lLn, LONG wServ, LONG *lpwFcn,
				LONG *lpwSa, LONG *lpwDat, LONG *lpwErr );
void SedFt  ( LONG lLn, LONG *lpwPat, LONG *lpwArr, LONG wBl,
							LONG *lplDerr, LONG *lpwSerr, LONG *lpwErr );
void SedEst ( LONG lLn, LONG *lpwErr );

// SedSer
void SedDly ( LONG lLn, LONG *lplDly, LONG *lplErr );
void SedLcs ( LONG lLn, LONG lCn, LONG *lplNum, LONG *lplArr, LONG *lplErr );
void SedVer ( LONG lLn, CHAR *lpszVer, LONG *lplErr );
void SedTyp ( LONG lLn, LONG *lplHdwTyp, LONG *lplHdwRel,
       LONG *lplFirVer, LONG *lplFirRel, LONG *lplFifLen, LONG *lplErr );
void SedDef ( LONG lLn, LONG *lplErr );
void SedSta ( LONG lLn, LONG lClr, LONG *lplSta, LONG *lplErr );

// SedCnt
void SedCac ( LONG lLn, LONG *lplErr );
void SedCnt ( LONG lLn, LONG *lplArr, LONG *lplErr );
void SedErc ( LONG lLn, LONG lCn, LONG lClass, LONG *lplArr, LONG *lplErr );

//-------+---------+---------+---------+---------+---------+---------+---------+


//		Sed1Pc/SedPc Summary of Error-Messages
//
//		you will get Errors with an enabled ScreenSaver.
//
//	*lplErr : error-status-bits used in all SEDxx-functions
//
//		15
//		14	Error in IoPermission
//		13	illegal SEDPC Type
//		12	no such LineNumber
//
//		11
//		10	ArrayOverflow
//		9
//		8
//
//		7	ParameterError: one Parameter incorrect
//		6	Response/Busy not set; Data not taken by SEDPC
//		5	Bytecount mismatch or wrong Function
//		4	Timeout: no Response from SEDPC
//
//		3	LastByte Marker not set or illegal Function
//		2..0	Code of Sedac Error
//
//			Sed1Pc 					SedPc
//		0 = no Error			0 = no Error
//		1 = Response Error		1 = Response Error
//		2 = Parity Error		2 = Parity Error
//		3 = Delay Timeout		3 = Delay Timeout
//		4 = Framing Error		4 = Framing Error
//		5 = Mysterious Error	5 = Mysterious Error
//		6 = LineFifo full		6 = n.a.
//		7 = PcFifo empty		7 = PcFifo empty
//
//		Mysterious Error: EndMark or EmptyFlag wrong
//
//		ErrorCounter:	RspErr: SedacStat = 7 or F
//						SedErr: SedacStat > 0 .. < 7
//						MysErr: SedacStat = 8, SedFifo empty, or
//												SedFifo LastByteMarker wrong

// end of SedPc.h
