// pdoclient.h
#ifndef PDOCLIENT_H
#define PDOCLIENT_H

#include <sys/time.h>
#include <time.h>
#include "tine.h"

#define QDEFAULT 1
#define QFIN     0
#define QDELAY   100
#define QUERYNUM  101
#define RECVNUM   102
#define QUERYDEV  103
#define RECVDEV  104
#define SETTIME  110
#define RECVTIME  111

#define MAXCANID  127

typedef long long long64;

// struct for table with PDO devices (Max 1 entry per CanId)
typedef struct { 
  short canId;      // This CanId
  short devHbInd;   // CDI Device Index for HB 
  short devPdoInd;  // CDI Device Index for (1rst) PDO
  short devCoType;  // unused ?
  short resetId[5]; //  > max=4 for logic 13.01.11
  int hbTimestamp;  // refreshed via subscribe
  int pdoTimestamp; // refreshed via subscribe
} CoInfo;
int nDevice;    // total # of devices
int nCoDevice;  // size of PDO struct table
int stateFlag;
int npdo; // 1 - 4 for PDO#
short devsdo16;
int rcCallback;
long64 tstart, tlast;
long64 tcycle;
char tineAddress[64];
char devAddress[96];
// ----- for PDO/HB monitoring -----
int hbTimestamp[MAXCANID];
int nHb;
DTYPE hbOut;  // only need 1 since data irrelevant?
int hbData;
NAME32* devlist;   /* all CDI device names */
CoInfo* coInfo;
DTYPE pdOut;  // only need 1 since data irrelevant?
int pdoData;
// ------------------------------
DTYPE dDevNum;
DTYPE dDevList;
DTYPE dDevSdo16;
short tpdo;   

void PdoClientInit();
int CountCoDevices();
void RegisterCoDevices();
void SubscribeCoDevices();
int PdoInitCycle(void);
void PdoMonitorCycle();
int nextIndex(int init);
int nextResetIndex(int init, int coInd);
void SetPdoStateflag(int sf);
int SetPdoTimeInt(int ipdo);
int RecvDevSdo16();
int SendDevSdo16(short data, int id);
void CallbackSdo(int id, int rc);
int  SubscribePdo(int ipdo, int ico);
void CallbackPdo(int id, int rc);
int  SubscribeHb(int ihb, int ico);
void CallbackHb(int id, int rc);
int PdoStatus(int,int,int,int);
long64 msectime();

#endif /* PDOCLIENT_H */
